#!/usr/bin/env python
# wabaroK thread input

import threading,sys,logging
logger=logging.getLogger('inputFromAmarok')

class inputFromAmarok(threading.Thread):
   def __init__(self,input,configDialog=None):
      """Constructor
      in:stdin of amaroK script"""
      threading.Thread.__init__(self)
      self.setDaemon(True)
      self.input = input
      self.configDialog=configDialog

   def configure(self):
      """Call configuration dialog"""
      logger.info("Configuration...")
      if callable(self.configDialog):
         self.configDialog()

   def run(self):
      while 1:
         line = self.input.readline().rstrip('\n')
         if not line: break
         # treat input
         #print line
         if line in dir(self) and callable(getattr(self,line)):
            getattr(self,line)()

if __name__=="__main__":
   background = inputFromAmarok(sys.stdin)
   background.start()
   logger.info('The main program continues to run in foreground.')
    
   background.join()    # Wait for the background task to finish